<?php

namespace GopNext\Controllers;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class CalculationBudgetController {
    
    protected $crudService;
  
    public function __construct($connection, $environment, $util, $crudService) {
        $this->connection   = $connection;
        $this->environment  = $environment;
        $this->util         = $util;
        $this->crudService	= $crudService;
    }
    
    public function budgetParameters(Request\Filter $request, Response $response) {
        $params = ['CDOPERADOR', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);
        
        $data = $this->crudService->getFilteredDataSet('budgetParameters', $conditions)->getRows();
		$response->addDataSet(new DataSet("budgetParameters", $data));
    }
    
    public function gridSummary(Request\Filter $request, Response $response) {
        $params = ['CDOPERADOR', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);
        $filter = $request->getFilterCriteria()->getConditions();
        
        foreach ($filter as &$item) {
            if ($item["columnName"] === "NRPERIODOORCA" && is_array($item["value"])) {
                $item["value"] = $item["value"]["NRPERIODOORCA"];
            }
        }
        
        $data = $this->crudService->getFilteredDataSet('gridSummary', array_merge($conditions, $filter))->getRows();
		$response->addDataSet(new DataSet("gridSummary", $data));
    }
}