import { Http } from '@zeedhi/core';

class BudgetParameters {
  private budgetParameters = [];
  
  private budgetParametersHandled = [];
  
  async getBudgetParameters() {
    const routeName = 'budgetParameters';
    const sendObject = {
      filter: [],
    };
    
    await Http.post(`/${routeName}`, sendObject).then((response) => {
      /* eslint no-console: ["error", { allow: ["warn", "error", "info", "log"] }] */
      this.budgetParameters = response.data.dataset[routeName];
    });
  }

  get getParameters(): any {
    return this.budgetParameters[0];
  }
  
  // public treatParameters(parameters: any) {
  //   const period = this.getParameters.IDPERIODOORCA;
  //   const filter = Object.entries(parameters).map(([key, values]) => ({
  //     name: key,
  //     operator: '=',
  //     value: Array.isArray(values) || !values
  //       ? this.arrayToText(values, key)
  //       : values,
  //   }));

  //   this.budgetParametersHandled = filter;
  // }
  public treatParameters(parameters: any) {
    const period = this.getParameters.IDPERIODOORCA;
    const filter = Object.entries(parameters).map(([key, values]) => {
      let aux;
      if (key === 'IDPERIODOORCA' && period) {
        aux = period;
      } else if (Array.isArray(values) || !values) {
        aux = key === 'IDPERIODOORCA' ? period : this.arrayToText(values, key);
      } else {
        aux = values;
      }
      return {
        name: key,
        operator: '=',
        value: aux,
      };
    });

    this.budgetParametersHandled = filter;
  }
  
  arrayToText(arr: any, key: string) {
    const aux = key === 'NRPERIODOORCA' ? 1 : null;
    return arr && arr.length > 0 ? `_${arr.map((obj) => obj[key]).join('_')}_` : aux;
  }

  get getParametersHandled(): any {
    return this.budgetParametersHandled;
  }
}

export default new BudgetParameters();
