import Vue from 'vue';
import Zeedhi from '@zeedhi/vue';
import ZeedhiComponents from '@zeedhi/vuetify';
import { Icons } from '@zeedhi/common';
import { ZdCrosstabEditable } from '@zeedhi/zd-crosstab-vue';
import { Mask } from '@zeedhi/core';
import controllers from '../controllers';
import config from '../config/config';
import '@zeedhi/common/dist/style.css';
import '@zeedhi/vuetify/dist/zd-style.css';
import vuetify from './vuetify';

Icons.addIcons({
  iconName: 'mdi-icon-id',
});

Vue.use(Zeedhi, {
  controllers,
  config,
});
Vue.use(ZeedhiComponents);

Vue.component('ZdCrosstabEditable', ZdCrosstabEditable);
Mask.addPattern('9', /[0,1,2,3,4,5,6,7,8,9]/);

vuetify.framework.icons.values = Icons.getIcons() as any;
